## czmq 4.0.0

=== CMakeLists.txt ===
################################################################################
#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
#  Read the zproject/README.md for information about making permanent changes. #
################################################################################

########################################################################
# Project setup
########################################################################
cmake_minimum_required(VERSION 2.8)
project(czmq)
enable_language(C)
enable_testing()

set(SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
# Select flags
SET(CMAKE_C_FLAGS_RELEASE "-O3")

# Will be used to add flags to pkg-config useful when apps want to statically link
set(pkg_config_libs_private "")

########################################################################
# options
########################################################################
if (NOT CMAKE_BUILD_TYPE)
    if (EXISTS "${SOURCE_DIR}/.git")
        set (CMAKE_BUILD_TYPE Debug)
    else ()
        set (CMAKE_BUILD_TYPE Release)
    endif ()
endif ()
if (${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    OPTION (ENABLE_DRAFTS "Build and install draft classes and methods" ON)
else ()
    OPTION (ENABLE_DRAFTS "Build and install draft classes and methods" OFF)
endif ()
IF (ENABLE_DRAFTS)
    ADD_DEFINITIONS (-DCZMQ_BUILD_DRAFT_API)
ENDIF (ENABLE_DRAFTS)

########################################################################
# platform.h
########################################################################
include(CheckIncludeFile)
CHECK_INCLUDE_FILE("linux/wireless.h" HAVE_LINUX_WIRELESS_H)
CHECK_INCLUDE_FILE("net/if_media.h" HAVE_NET_IF_MEDIA_H)

include(CheckFunctionExists)
CHECK_FUNCTION_EXISTS("getifaddrs" HAVE_GETIFADDRS)
CHECK_FUNCTION_EXISTS("freeifaddrs" HAVE_FREEIFADDRS)

include(CheckIncludeFiles)
check_include_files("sys/socket.h;net/if.h" HAVE_NET_IF_H)
if (NOT HAVE_NET_IF_H)
    CHECK_INCLUDE_FILE("net/if.h" HAVE_NET_IF_H)
endif()

file(WRITE "${SOURCE_DIR}/src/platform.h.in" "
#cmakedefine HAVE_LINUX_WIRELESS_H
#cmakedefine HAVE_NET_IF_H
#cmakedefine HAVE_NET_IF_MEDIA_H
#cmakedefine HAVE_GETIFADDRS
#cmakedefine HAVE_FREEIFADDRS
")

configure_file("${SOURCE_DIR}/src/platform.h.in" "${SOURCE_DIR}/src/platform.h")

#The MSVC C compiler is too out of date,
#so the sources have to be compiled as c++
if (MSVC)
    enable_language(CXX)
    file(GLOB sources "${SOURCE_DIR}/src/*.c")
    set_source_files_properties(
        ${sources}
        PROPERTIES LANGUAGE CXX
    )
    set(MORE_LIBRARIES ws2_32 Rpcrt4 Iphlpapi)
endif()

# required libraries for mingw
if (MINGW)
    set(MORE_LIBRARIES -lws2_32 -lrpcrt4 -liphlpapi)
endif()

# required libraries for cygwin
if (CYGWIN)
    set(MORE_LIBRARIES)
endif()

list(APPEND CMAKE_MODULE_PATH "${SOURCE_DIR}")
set(OPTIONAL_LIBRARIES)

########################################################################
# LIBZMQ dependency
########################################################################
find_package(libzmq REQUIRED)
IF (LIBZMQ_FOUND)
    include_directories(${LIBZMQ_INCLUDE_DIRS})
    list(APPEND MORE_LIBRARIES ${LIBZMQ_LIBRARIES})
    set(pkg_config_libs_private "${pkg_config_libs_private} -lzmq")
ELSE (LIBZMQ_FOUND)
    message( FATAL_ERROR "libzmq not found." )
ENDIF (LIBZMQ_FOUND)

########################################################################
# UUID dependency
########################################################################
find_package(uuid)
IF (UUID_FOUND)
    include_directories(${UUID_INCLUDE_DIRS})
    list(APPEND MORE_LIBRARIES ${UUID_LIBRARIES})
    set(pkg_config_libs_private "${pkg_config_libs_private} -luuid")
    add_definitions(-DHAVE_UUID)
    list(APPEND OPTIONAL_LIBRARIES ${UUID_LIBRARIES})
ENDIF (UUID_FOUND)

########################################################################
# SYSTEMD dependency
########################################################################
find_package(systemd)
IF (SYSTEMD_FOUND)
    include_directories(${SYSTEMD_INCLUDE_DIRS})
    list(APPEND MORE_LIBRARIES ${SYSTEMD_LIBRARIES})
    set(pkg_config_libs_private "${pkg_config_libs_private} -lsystemd")
    add_definitions(-DHAVE_LIBSYSTEMD)
    list(APPEND OPTIONAL_LIBRARIES ${SYSTEMD_LIBRARIES})
ENDIF (SYSTEMD_FOUND)

########################################################################
# includes
########################################################################
set (czmq_headers
    include/czmq_library.h
    include/czmq_prelude.h
    include/czmq.h
    include/zactor.h
    include/zarmour.h
    include/zcert.h
    include/zcertstore.h
    include/zchunk.h
    include/zclock.h
    include/zconfig.h
    include/zdigest.h
    include/zdir.h
    include/zdir_patch.h
    include/zfile.h
    include/zframe.h
    include/zhash.h
    include/zhashx.h
    include/ziflist.h
    include/zlist.h
    include/zlistx.h
    include/zloop.h
    include/zmsg.h
    include/zpoller.h
    include/zsock.h
    include/zstr.h
    include/zuuid.h
    include/zauth.h
    include/zbeacon.h
    include/zgossip.h
    include/zmonitor.h
    include/zproxy.h
    include/zrex.h
    include/zsys.h
    src/zgossip_msg.h
    src/zsock_option.inc
    src/zgossip_engine.inc
    src/zhash_primes.inc
    src/foreign/sha1/sha1.inc_c
    src/foreign/sha1/sha1.h
    src/foreign/slre/slre.inc_c
    src/foreign/slre/slre.h
    src/foreign/slre/readme.txt
)

IF (ENABLE_DRAFTS)
    list(APPEND czmq_headers
        include/zproc.h
        include/ztimerset.h
        include/ztrie.h
    )
ENDIF (ENABLE_DRAFTS)

source_group ("Header Files" FILES ${czmq_headers})
install(FILES ${czmq_headers} DESTINATION include)

########################################################################
# library
########################################################################
include_directories("${SOURCE_DIR}/src" "${SOURCE_DIR}/include")
set (czmq_sources
    src/zactor.c
    src/zarmour.c
    src/zcert.c
    src/zcertstore.c
    src/zchunk.c
    src/zclock.c
    src/zconfig.c
    src/zdigest.c
    src/zdir.c
    src/zdir_patch.c
    src/zfile.c
    src/zframe.c
    src/zhash.c
    src/zhashx.c
    src/ziflist.c
    src/zlist.c
    src/zlistx.c
    src/zloop.c
    src/zmsg.c
    src/zpoller.c
    src/zsock.c
    src/zstr.c
    src/zuuid.c
    src/zauth.c
    src/zbeacon.c
    src/zgossip.c
    src/zmonitor.c
    src/zproxy.c
    src/zrex.c
    src/zsys.c
    src/zgossip_msg.c
)

IF (ENABLE_DRAFTS)
    list (APPEND czmq_sources
        src/zproc.c
        src/ztimerset.c
        src/ztrie.c
    )
ENDIF (ENABLE_DRAFTS)

source_group("Source Files" FILES ${czmq_sources})
if (NOT DEFINED BUILD_SHARED_LIBS)
    SET(BUILD_SHARED_LIBS ON)
endif()
add_library(czmq ${czmq_sources})
set_target_properties(czmq
    PROPERTIES DEFINE_SYMBOL "CZMQ_EXPORTS"
)
set_target_properties(czmq
    PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${SOURCE_DIR}/src"
)
target_link_libraries(czmq
    ${ZEROMQ_LIBRARIES} ${MORE_LIBRARIES}
)

install(TARGETS czmq
    LIBRARY DESTINATION "lib${LIB_SUFFIX}" # .so file
    ARCHIVE DESTINATION "lib${LIB_SUFFIX}" # .lib file
    RUNTIME DESTINATION bin              # .dll file
)

include(${CMAKE_CURRENT_SOURCE_DIR}/src/CMakeLists-local.txt) # Optional project-local hook

########################################################################
# pkgconfig
########################################################################
set (VERSION "4.0.0")
set (prefix "${CMAKE_INSTALL_PREFIX}")
set (exec_prefix "\${prefix}")
set (libdir "\${prefix}/lib${LIB_SUFFIX}")
set (includedir "\${prefix}/include")
IF (ENABLE_DRAFTS)
    set (pkg_config_defines "-DCZMQ_BUILD_DRAFT_API=1")
ELSE (ENABLE_DRAFTS)
    set (pkg_config_defines "")
ENDIF (ENABLE_DRAFTS)
configure_file(
    "${SOURCE_DIR}/src/libczmq.pc.in"
    "${SOURCE_DIR}/src/libczmq.pc"
@ONLY)

install(
    FILES "${SOURCE_DIR}/src/libczmq.pc"
    DESTINATION "lib${LIB_SUFFIX}/pkgconfig"
)

########################################################################
# executables
########################################################################
add_executable(
    zmakecert
    "${SOURCE_DIR}/src/zmakecert.c"
)
target_link_libraries(
    zmakecert
    czmq
    ${LIBZMQ_LIBRARIES}
    ${OPTIONAL_LIBRARIES}
)
set_target_properties(
    zmakecert
    PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${SOURCE_DIR}/src"
)
add_executable(
    czmq_selftest
    "${SOURCE_DIR}/src/czmq_selftest.c"
)
target_link_libraries(
    czmq_selftest
    czmq
    ${LIBZMQ_LIBRARIES}
    ${OPTIONAL_LIBRARIES}
)
set_target_properties(
    czmq_selftest
    PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${SOURCE_DIR}/src"
)

########################################################################
# tests
########################################################################
set(CLASSTEST_TIMEOUT 60 CACHE STRING "Timeout of the selftest of a class")
set(TOTAL_TIMEOUT 600 CACHE STRING "Timout of the total testsuite")

if(UNIX)
    find_program(MEMORYCHECK_COMMAND valgrind)
    set(MEMORYCHECK_COMMAND_OPTIONS "--leak-check=full --show-reachable=yes
                                     --error-exitcode=1
                                     --suppressions=src/.valgrind.supp")
endif()

set(TEST_CLASSES
    zactor
    zarmour
    zcert
    zcertstore
    zchunk
    zclock
    zconfig
    zdigest
    zdir
    zdir_patch
    zfile
    zframe
    zhash
    zhashx
    ziflist
    zlist
    zlistx
    zloop
    zmsg
    zpoller
    zsock
    zstr
    zuuid
    zauth
    zbeacon
    zgossip
    zmonitor
    zproxy
    zrex
    zsys
    zgossip_msg
)

IF (ENABLE_DRAFTS)
    list (APPEND TEST_CLASSES
    zproc
    ztimerset
    ztrie
    )
ENDIF (ENABLE_DRAFTS)

foreach(TEST_CLASS ${TEST_CLASSES})
    add_test(
        NAME ${TEST_CLASS}
        COMMAND czmq_selftest --continue --verbose --test ${TEST_CLASS}
    )
    set_tests_properties(
        ${TEST_CLASS}
        PROPERTIES TIMEOUT ${CLASSTEST_TIMEOUT}
    )
endforeach(TEST_CLASS)

include(CTest)

########################################################################
# cleanup
########################################################################
add_custom_target (distclean @echo Cleaning for source distribution)

set(cmake_generated ${CMAKE_BINARY_DIR}/CMakeCache.txt
                    ${CMAKE_BINARY_DIR}/cmake_install.cmake
                    ${CMAKE_BINARY_DIR}/Makefile
                    ${CMAKE_BINARY_DIR}/CMakeFiles
                    ${CMAKE_BINARY_DIR}/CTestTestfile.cmake
                    ${CMAKE_BINARY_DIR}/DartConfiguration.tcl
                    ${CMAKE_BINARY_DIR}/Testing
                    ${CMAKE_BINARY_DIR}/compile_commands.json
                    ${CMAKE_BINARY_DIR}/src/platform.h
                    ${CMAKE_BINARY_DIR}/src/libczmq.pc
                    ${CMAKE_BINARY_DIR}/src/libczmq.so
                    ${CMAKE_BINARY_DIR}/src/czmq_selftest
                    ${CMAKE_BINARY_DIR}/src/zmakecert
                    ${CMAKE_BINARY_DIR}/src/czmq_selftest
)

add_custom_command(
    DEPENDS clean
    COMMENT "distribution clean"
    COMMAND rm
    ARGS    -rf CMakeTmp ${cmake_generated}
    TARGET  distclean
)

########################################################################
# summary
########################################################################
message ("")
message (STATUS "******************* Configuration Summary *******************")
message (STATUS "General:")
message (STATUS "  Version           :   ${VERSION}")
message (STATUS "  System            :   ${CMAKE_SYSTEM_NAME}")
message (STATUS "  C compiler        :   ${CMAKE_C_COMPILER}")
message (STATUS "  Debug C flags     :   ${CMAKE_C_FLAGS_DEBUG} ${CMAKE_C_FLAGS}")
message (STATUS "  Release C flags   :   ${CMAKE_C_FLAGS_RELEASE} ${CMAKE_C_FLAGS}")
message (STATUS "  Build type        :   ${CMAKE_BUILD_TYPE}")
IF (ENABLE_DRAFTS)
message (STATUS "  Draft API         :   Yes")
ELSE (ENABLE_DRAFTS)

## czmq 3.0.2

=== debian/changelog ===
czmq (3.0.2-5) unstable; urgency=medium

  * Add 0005-zauth-test-hang.patch to fix test.
    Backport from upstream to fix FTBS on ARM64 and ALPHA.

 -- Luca Boccassi <luca.boccassi@gmail.com>  Thu, 10 Mar 2016 11:50:49 +0000

czmq (3.0.2-4) unstable; urgency=medium

  * Add 0004-zauth-v2-test-hang.patch to fix test.
    Backport patch from upstream to fix unit test race
    condition in zauth_v2.
  * Don't fail build if UT fail on slower archs.
    There are known upstream issues with race conditions
    in the unit tests, that can cause a failure on slower
    environments. As a workaround, have a failure in
    dh_auto_test stop the build only on amd64 and i386.

 -- Luca Boccassi <luca.boccassi@gmail.com>  Wed, 09 Mar 2016 16:53:58 +0000

czmq (3.0.2-3) unstable; urgency=medium

  * Bump s-v to 3.9.7, no changes required
  * Bump dependency to libzmq5-dev. (Closes: #815784)
    Thanks Svante Signell!

 -- Luca Boccassi <luca.boccassi@gmail.com>  Wed, 24 Feb 2016 19:52:58 +0000

czmq (3.0.2-2) unstable; urgency=medium

  * Add patch to support GNU/Hurd (Closes: 801113)
    Thanks Svante Signell!

 -- Luca Boccassi <luca.boccassi@gmail.com>  Tue, 06 Oct 2015 16:45:50 +0100

czmq (3.0.2-1) unstable; urgency=low

  * Initial release (Closes: #630761)
  * Backport patch to fix signal handling
  * Add patch to check for and link against pthread
  * Added Alessandro Ghedini in the Uploaders field

 -- Luca Boccassi <luca.boccassi@gmail.com>  Fri, 31 Jul 2015 10:32:08 +0100

=== debian/control ===
Source: czmq
Priority: optional
Maintainer: Luca Boccassi <luca.boccassi@gmail.com>
Uploaders: Alessandro Ghedini <ghedo@debian.org>
Build-Depends: debhelper (>= 9),
 autotools-dev,
 pkg-config,
 dh-autoreconf,
 libzmq5-dev
Standards-Version: 3.9.7
Section: libs
Homepage: http://czmq.zeromq.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/czmq.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/czmq.git

Package: libczmq3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: High-level C binding for ZeroMQ
 czmq (previously known as libzapi) provides a high-level C binding for
 0MQ, a lightweight messaging library.
 .
 This library provides higher level abstractions on top of the base
 library, with features such as:
  * Work with messages as strings, individual frames, or multipart messages.
  * Automatic closure of any open sockets at context termination.
  * Automatic LINGER configuration of all sockets for context termination.
  * Portable API for creating child threads and ØMQ pipes to talk to them.
  * Simple reactor with one-off and repeated timers, and socket readers.
  * System clock functions for sleeping and calculating timers.
  * Easy API to get/set all socket options.
  * Includes generic hash and list containers.

Package: libczmq-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libzmq5-dev,
         libczmq3 (= ${binary:Version})
Multi-Arch: same
Description: High-level C binding for ZeroMQ (development files)
 czmq (previously known as libzapi) provides a high-level C binding for
 0MQ, a lightweight messaging library.
 .
 This library provides higher level abstractions on top of the base
 library, with features such as:
  * Work with messages as strings, individual frames, or multipart messages.
  * Automatic closure of any open sockets at context termination.
  * Automatic LINGER configuration of all sockets for context termination.
  * Portable API for creating child threads and ØMQ pipes to talk to them.
  * Simple reactor with one-off and repeated timers, and socket readers.
  * System clock functions for sleeping and calculating timers.
  * Easy API to get/set all socket options.
  * Includes generic hash and list containers.
 .
 This package provides the development files for czmq.

Package: libczmq-dbg
Priority: extra
Section: debug
Architecture: any
Depends: ${misc:Depends}, libczmq3 (= ${binary:Version})
Multi-Arch: same
Description: High-level C binding for ZeroMQ (debugging symbols)
 czmq (previously known as libzapi) provides a high-level C binding for
 0MQ, a lightweight messaging library.
 .
 This library provides higher level abstractions on top of the base
 library, with features such as:
  * Work with messages as strings, individual frames, or multipart messages.
  * Automatic closure of any open sockets at context termination.
  * Automatic LINGER configuration of all sockets for context termination.
  * Portable API for creating child threads and ØMQ pipes to talk to them.
  * Simple reactor with one-off and repeated timers, and socket readers.
  * System clock functions for sleeping and calculating timers.
  * Easy API to get/set all socket options.
  * Includes generic hash and list containers.
 .
 This package provides the debugging symbols for czmq.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

%:
	dh $@ --with autoreconf

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_strip:
	dh_strip --dbg-package=libczmq-dbg

ifeq (,$(filter $(shell dpkg-architecture -qDEB_BUILD_ARCH),i386 amd64))
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	-dh_auto_test -- VERBOSE=1
endif
endif

=== debian/watch ===
version=3

http://download.zeromq.org/czmq-(.*)\.tar\.gz

## czmq 4.0.0

=== debian/changelog ===
czmq (4.0.0-3) unstable; urgency=medium

  * Upload to unstable

 -- Luca Boccassi <luca.boccassi@gmail.com>  Mon, 07 Nov 2016 21:19:28 +0000

czmq (4.0.0-2) experimental; urgency=medium

  * Fix private/draft symbols leakage
  * Refresh symbols list after fixing leakage

 -- Luca Boccassi <luca.boccassi@gmail.com>  Sun, 06 Nov 2016 10:38:52 +0000

czmq (4.0.0-1) experimental; urgency=medium

  * New upstream version 4.0.0
  * Refresh and drop patches for v4.0.0
  * Rename package libczmq3 -> libczmq4 for ABI bump
  * Explicitly disable DRAFT APIs when building
  * Refresh libczmq4.symbols

 -- Luca Boccassi <luca.boccassi@gmail.com>  Sat, 05 Nov 2016 02:09:40 +0000

czmq (3.0.2-10) unstable; urgency=medium

  * Add 0011-remove-readdir_r.patch to backport fix for readdir_r,
    deprecated in glibc 2.24. (Closes: #836307)
  * Add 0012-fix-missing-defined.patch to backport fix for missing
    defined() in czmq_prelude.h. Fixes build error with debug flags
    enabled.

 -- Luca Boccassi <luca.boccassi@gmail.com>  Fri, 02 Sep 2016 12:06:33 +0100

czmq (3.0.2-9) unstable; urgency=medium

  * Backport 0009-zmsg-double-resolve.patch and
    0010-zsock-resolve-zmq-handle.patch to fix huge performance drop
    in zmsg_send/recv due to double zsock_resolve which caused a getsockopt
    syscall to happen everytime

 -- Luca Boccassi <luca.boccassi@gmail.com>  Thu, 11 Aug 2016 16:47:09 +0100

czmq (3.0.2-8) unstable; urgency=medium

  * Remove Alessandro Ghedini from Uploaders as requested.
    Thank you for your work and your help!
  * Update d/watch for new Github-based releases
  * Add 0007-zdir-zlist-zsock-memory-leaks.patch to backport various
    memory leaks
  * Add 0008-zlist-dup-autofree-leak.patch to backport zlist_dup autofree
    memory leak

 -- Luca Boccassi <luca.boccassi@gmail.com>  Tue, 02 Aug 2016 14:51:02 +0100

czmq (3.0.2-7) unstable; urgency=medium

  * Don't fail if tests fail on any arch
  * Bump Standards-Version to 3.9.8, no change

 -- Luca Boccassi <luca.boccassi@gmail.com>  Mon, 25 Apr 2016 23:13:18 +0100

czmq (3.0.2-6) unstable; urgency=medium

  * Backport patch to fix off-by-one in zsock_recv
  * Change [build-]dependency back to libzmq3-dev
  * Add sha1 and slre headers licenses in d/copyright
  * L-W: Use HTTPS link for Vcs-Git
  * L-W: use hardening=+all

 -- Luca Boccassi <luca.boccassi@gmail.com>  Mon, 25 Apr 2016 18:19:52 +0100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,18 @@
 Source: czmq
 Priority: optional
 Maintainer: Luca Boccassi <luca.boccassi@gmail.com>
-Uploaders: Alessandro Ghedini <ghedo@debian.org>
 Build-Depends: debhelper (>= 9),
  autotools-dev,
  pkg-config,
  dh-autoreconf,
- libzmq5-dev
-Standards-Version: 3.9.7
+ libzmq3-dev
+Standards-Version: 3.9.8
 Section: libs
 Homepage: http://czmq.zeromq.org/
-Vcs-Git: git://anonscm.debian.org/collab-maint/czmq.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/czmq.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/czmq.git
 
-Package: libczmq3
+Package: libczmq4
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
@@ -37,8 +36,8 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends},
-         libzmq5-dev,
-         libczmq3 (= ${binary:Version})
+         libzmq3-dev,
+         libczmq4 (= ${binary:Version})
 Multi-Arch: same
 Description: High-level C binding for ZeroMQ (development files)
  czmq (previously known as libzapi) provides a high-level C binding for
@@ -61,7 +60,7 @@
 Priority: extra
 Section: debug
 Architecture: any
-Depends: ${misc:Depends}, libczmq3 (= ${binary:Version})
+Depends: ${misc:Depends}, libczmq4 (= ${binary:Version})
 Multi-Arch: same
 Description: High-level C binding for ZeroMQ (debugging symbols)
  czmq (previously known as libzapi) provides a high-level C binding for

## czmq 4.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -242,6 +242,9 @@
 set_target_properties(czmq
     PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${SOURCE_DIR}/src"
 )
+set_target_properties (czmq
+    PROPERTIES SOVERSION "4.0.2"
+)
 target_link_libraries(czmq
     ${ZEROMQ_LIBRARIES} ${MORE_LIBRARIES}
 )
@@ -257,7 +260,7 @@
 ########################################################################
 # pkgconfig
 ########################################################################
-set (VERSION "4.0.0")
+set (VERSION "4.0.2")
 set (prefix "${CMAKE_INSTALL_PREFIX}")
 set (exec_prefix "\${prefix}")
 set (libdir "\${prefix}/lib${LIB_SUFFIX}")
@@ -353,7 +356,6 @@
     zproxy
     zrex
     zsys
-    zgossip_msg
 )
 
 IF (ENABLE_DRAFTS)
@@ -419,5 +421,3 @@
 message (STATUS "  Release C flags   :   ${CMAKE_C_FLAGS_RELEASE} ${CMAKE_C_FLAGS}")
 message (STATUS "  Build type        :   ${CMAKE_BUILD_TYPE}")
 IF (ENABLE_DRAFTS)
-message (STATUS "  Draft API         :   Yes")
-ELSE (ENABLE_DRAFTS)

=== bindings/jni/CMakeLists.txt ===
################################################################################
#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
#  Read the zproject/README.md for information about making permanent changes. #
################################################################################
cmake_minimum_required (VERSION 2.8)

project (czmqjni CXX)
enable_language (C)

# Search for Find*.cmake files in the following locations
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/../..")

########################################################################
# JNI dependency
########################################################################
find_package (JNI REQUIRED)
include_directories (${JAVA_INCLUDE_PATH} ${JAVA_INCLUDE_PATH2} src/native/include)

########################################################################
# LIBZMQ dependency
########################################################################
find_package(libzmq REQUIRED)
IF (LIBZMQ_FOUND)
    include_directories(${LIBZMQ_INCLUDE_DIRS})
    list(APPEND MORE_LIBRARIES ${LIBZMQ_LIBRARIES})
ELSE (LIBZMQ_FOUND)
    message( FATAL_ERROR "libzmq not found." )
ENDIF (LIBZMQ_FOUND)

########################################################################
# CZMQ dependency
########################################################################
find_package(czmq REQUIRED)
IF (CZMQ_FOUND)
    include_directories(${CZMQ_INCLUDE_DIRS})
    list(APPEND MORE_LIBRARIES ${CZMQ_LIBRARIES})
ELSE (CZMQ_FOUND)
    message( FATAL_ERROR "czmq not found." )
ENDIF (CZMQ_FOUND)

set (czmqjni_sources
    src/main/c/org_zeromq_czmq_Zarmour.c
    src/main/c/org_zeromq_czmq_Zcert.c
    src/main/c/org_zeromq_czmq_Zcertstore.c
    src/main/c/org_zeromq_czmq_Zchunk.c
    src/main/c/org_zeromq_czmq_Zclock.c
    src/main/c/org_zeromq_czmq_Zconfig.c
    src/main/c/org_zeromq_czmq_Zdigest.c
    src/main/c/org_zeromq_czmq_Zdir.c
    src/main/c/org_zeromq_czmq_ZdirPatch.c
    src/main/c/org_zeromq_czmq_Zfile.c
    src/main/c/org_zeromq_czmq_Zframe.c
    src/main/c/org_zeromq_czmq_Zhash.c
    src/main/c/org_zeromq_czmq_Zhashx.c
    src/main/c/org_zeromq_czmq_Ziflist.c
    src/main/c/org_zeromq_czmq_Zlist.c
    src/main/c/org_zeromq_czmq_Zlistx.c
    src/main/c/org_zeromq_czmq_Zloop.c
    src/main/c/org_zeromq_czmq_Zmsg.c
    src/main/c/org_zeromq_czmq_Zpoller.c
    src/main/c/org_zeromq_czmq_Zproc.c
    src/main/c/org_zeromq_czmq_Zsock.c
    src/main/c/org_zeromq_czmq_Zstr.c
    src/main/c/org_zeromq_czmq_Ztimerset.c
    src/main/c/org_zeromq_czmq_Ztrie.c
    src/main/c/org_zeromq_czmq_Zuuid.c
)

add_library (czmqjni SHARED ${czmqjni_sources})
add_definitions (-DCZMQ_BUILD_DRAFT_API)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic -O2")
set (CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build)
set (CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build)
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build)

target_link_libraries (czmqjni ${MORE_LIBRARIES})

=== bindings/jni/android/CMakeLists.txt ===
################################################################################
#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
#  Read the zproject/README.md for information about making permanent changes. #
################################################################################
cmake_minimum_required (VERSION 2.8)

project (czmqjni CXX)
enable_language (C)

# Search for Find*.cmake files in the following locations
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/..")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/../../..")

########################################################################
# JNI dependency
########################################################################
find_package (JNI REQUIRED)
include_directories (${JAVA_INCLUDE_PATH} ${JAVA_INCLUDE_PATH2} ../src/native/include)

########################################################################
# LIBZMQ dependency
########################################################################
find_package(libzmq REQUIRED)
IF (LIBZMQ_FOUND)
    include_directories(${LIBZMQ_INCLUDE_DIRS})
    list(APPEND MORE_LIBRARIES ${LIBZMQ_LIBRARIES})
ELSE (LIBZMQ_FOUND)
    message( FATAL_ERROR "libzmq not found." )
ENDIF (LIBZMQ_FOUND)

########################################################################
# CZMQ dependency
########################################################################
find_package(czmq REQUIRED)
IF (CZMQ_FOUND)
    include_directories(${CZMQ_INCLUDE_DIRS})
    list(APPEND MORE_LIBRARIES ${CZMQ_LIBRARIES})
ELSE (CZMQ_FOUND)
    message( FATAL_ERROR "czmq not found." )
ENDIF (CZMQ_FOUND)

set (czmqjni_sources
    ../src/main/c/org_zeromq_czmq_Zarmour.c
    ../src/main/c/org_zeromq_czmq_Zcert.c
    ../src/main/c/org_zeromq_czmq_Zcertstore.c
    ../src/main/c/org_zeromq_czmq_Zchunk.c
    ../src/main/c/org_zeromq_czmq_Zclock.c
    ../src/main/c/org_zeromq_czmq_Zconfig.c
    ../src/main/c/org_zeromq_czmq_Zdigest.c
    ../src/main/c/org_zeromq_czmq_Zdir.c
    ../src/main/c/org_zeromq_czmq_ZdirPatch.c
    ../src/main/c/org_zeromq_czmq_Zfile.c
    ../src/main/c/org_zeromq_czmq_Zframe.c
    ../src/main/c/org_zeromq_czmq_Zhash.c
    ../src/main/c/org_zeromq_czmq_Zhashx.c
    ../src/main/c/org_zeromq_czmq_Ziflist.c
    ../src/main/c/org_zeromq_czmq_Zlist.c
    ../src/main/c/org_zeromq_czmq_Zlistx.c
    ../src/main/c/org_zeromq_czmq_Zloop.c
    ../src/main/c/org_zeromq_czmq_Zmsg.c
    ../src/main/c/org_zeromq_czmq_Zpoller.c
    ../src/main/c/org_zeromq_czmq_Zproc.c
    ../src/main/c/org_zeromq_czmq_Zsock.c
    ../src/main/c/org_zeromq_czmq_Zstr.c
    ../src/main/c/org_zeromq_czmq_Ztimerset.c
    ../src/main/c/org_zeromq_czmq_Ztrie.c
    ../src/main/c/org_zeromq_czmq_Zuuid.c
)

add_library (czmqjni SHARED ${czmqjni_sources})
add_definitions (-DCZMQ_BUILD_DRAFT_API)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic -O2")
set (CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build)
set (CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build)
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build)

target_link_libraries (czmqjni ${MORE_LIBRARIES})

=== debian/changelog ===
czmq (4.0.2-7) unstable; urgency=medium

  * Add 0007-zhashx_purge-leak-when-shrinking.patch backported from
    upstream to fix memory leak in zhashx_purge when shrinking the table.
    (Closes: #864342)

 -- Luca Boccassi <luca.boccassi@gmail.com>  Wed, 07 Jun 2017 10:22:32 +0100

czmq (4.0.2-6) unstable; urgency=medium

  * Set version of symbols added by patch to 4.0.2-4~ to fix L:E

 -- Luca Boccassi <luca.boccassi@gmail.com>  Tue, 24 Jan 2017 13:30:47 +0000

czmq (4.0.2-5) unstable; urgency=medium

  * Build-depend on asciidoc-base | asciidoc
  * Disable unit tests run on MIPS (closes: #852372)

 -- Luca Boccassi <luca.boccassi@gmail.com>  Tue, 24 Jan 2017 11:56:33 +0000

czmq (4.0.2-4) unstable; urgency=medium

  * Backport patch to fix zmsg_remove refcount
  * Backport patch to fix zpoller_remove refcount
  * Backport patch to fix zsys_shutdown refcount
  * Backport patch to fix API changes depending on libzmq version

 -- Luca Boccassi <luca.boccassi@gmail.com>  Sun, 22 Jan 2017 19:02:49 +0000

czmq (4.0.2-3) unstable; urgency=medium

  * Backport patches to fix FTBFS on kFreeBSD

 -- Luca Boccassi <luca.boccassi@gmail.com>  Tue, 03 Jan 2017 00:54:10 +0100

czmq (4.0.2-2) unstable; urgency=medium

  * Set libsystemd-dev build-dep to [linux-any] to fix FTBFS on Hurd

 -- Luca Boccassi <luca.boccassi@gmail.com>  Sun, 01 Jan 2017 12:01:17 +0100

czmq (4.0.2-1) unstable; urgency=low

  * New upstream version 4.0.1
  * Drop pthread and hurd patches, merged upstream
  * Refresh symbols leak patch
  * Build-Depend on asciidoc and xmlto to generate manpages
  * Build-Depend on uuid-dev to use system uuid generation
  * Build-depend on libsystemd-dev for socket-base activation support
  * New upstream version 4.0.2
  * Drop symbols leak patch, fixed upstream
  * Install zproject API files in libczmq-dev package
  * Install man3 pages in libczmq-dev package

 -- Luca Boccassi <luca.boccassi@gmail.com>  Sat, 31 Dec 2016 21:12:48 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,11 @@
  autotools-dev,
  pkg-config,
  dh-autoreconf,
- libzmq3-dev
+ libzmq3-dev,
+ uuid-dev,
+ libsystemd-dev [linux-any],
+ asciidoc-base | asciidoc,
+ xmlto,
 Standards-Version: 3.9.8
 Section: libs
 Homepage: http://czmq.zeromq.org/

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH  := $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@ --with autoreconf


override_dh_auto_configure:
	dh_auto_configure -- --enable-drafts=no

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_strip:
	dh_strip --dbg-package=libczmq-dbg

# unit tests are too unreliable on buildd, even i386.
# and on mips it seems to hang, so avoid running it.
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifneq ($(DEB_HOST_ARCH),mips)
override_dh_auto_test:
	-dh_auto_test -- VERBOSE=1
else
override_dh_auto_test:
endif
endif

## czmq 4.0.2+git20170821

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,21 @@
     if (EXISTS "${SOURCE_DIR}/.git")
         set (CMAKE_BUILD_TYPE Debug)
     else ()
-        set (CMAKE_BUILD_TYPE Release)
+# http://xit0.org/2013/04/cmake-use-git-branch-and-commit-details-in-project/
+# http://stackoverflow.com/questions/6797395/cmake-execute-process-always-fails-with-no-such-file-or-directory-when-i-cal
+        execute_process(
+            COMMAND git rev-parse --show-toplevel
+            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
+            RESULT_VARIABLE git_result
+            OUTPUT_VARIABLE git_root
+            OUTPUT_STRIP_TRAILING_WHITESPACE
+        )
+        message(STATUS "git workspace root [${git_result}]: ${git_root}")
+        if ( "${git_result}" == "0" )
+            set (CMAKE_BUILD_TYPE Debug)
+        else ()
+            set (CMAKE_BUILD_TYPE Release)
+        endif ()
     endif ()
 endif ()
 if (${CMAKE_BUILD_TYPE} STREQUAL "Debug")
@@ -77,6 +91,13 @@
     set(MORE_LIBRARIES ws2_32 Rpcrt4 Iphlpapi)
 endif()
 
+# specific case of windows UWP
+if( ${CMAKE_SYSTEM_NAME} STREQUAL "WindowsStore" AND ${CMAKE_SYSTEM_VERSION} STREQUAL "10.0")
+  ADD_DEFINITIONS(-DZMQ_HAVE_WINDOWS_UWP)
+  ADD_DEFINITIONS(-D_WIN32_WINNT=_WIN32_WINNT_WIN10)
+endif()
+
+
 # required libraries for mingw
 if (MINGW)
     set(MORE_LIBRARIES -lws2_32 -lrpcrt4 -liphlpapi)
@@ -125,6 +146,18 @@
     add_definitions(-DHAVE_LIBSYSTEMD)
     list(APPEND OPTIONAL_LIBRARIES ${SYSTEMD_LIBRARIES})
 ENDIF (SYSTEMD_FOUND)
+
+########################################################################
+# LZ4 dependency
+########################################################################
+find_package(lz4)
+IF (LZ4_FOUND)
+    include_directories(${LZ4_INCLUDE_DIRS})
+    list(APPEND MORE_LIBRARIES ${LZ4_LIBRARIES})
+    set(pkg_config_libs_private "${pkg_config_libs_private} -llz4")
+    add_definitions(-DHAVE_LIBLZ4)
+    list(APPEND OPTIONAL_LIBRARIES ${LZ4_LIBRARIES})
+ENDIF (LZ4_FOUND)
 
 ########################################################################
 # includes
@@ -155,6 +188,7 @@
     include/zpoller.h
     include/zsock.h
     include/zstr.h
+    include/zsys.h
     include/zuuid.h
     include/zauth.h
     include/zbeacon.h
@@ -162,7 +196,6 @@
     include/zmonitor.h
     include/zproxy.h
     include/zrex.h
-    include/zsys.h
     src/zgossip_msg.h
     src/zsock_option.inc
     src/zgossip_engine.inc
@@ -176,6 +209,7 @@
 
 IF (ENABLE_DRAFTS)
     list(APPEND czmq_headers
+        include/zargs.h
         include/zproc.h
         include/ztimerset.h
         include/ztrie.h
@@ -212,6 +246,7 @@
     src/zpoller.c
     src/zsock.c
     src/zstr.c
+    src/zsys.c
     src/zuuid.c
     src/zauth.c
     src/zbeacon.c
@@ -219,18 +254,24 @@
     src/zmonitor.c
     src/zproxy.c
     src/zrex.c
-    src/zsys.c
     src/zgossip_msg.c
 )
 
 IF (ENABLE_DRAFTS)
     list (APPEND czmq_sources
+        src/zargs.c
         src/zproc.c
         src/ztimerset.c
         src/ztrie.c
     )
 ENDIF (ENABLE_DRAFTS)
 
+IF (ENABLE_DRAFTS)
+    list (APPEND czmq_sources
+        src/czmq_private_selftest.c
+    )
+ENDIF (ENABLE_DRAFTS)
+
 source_group("Source Files" FILES ${czmq_sources})
 if (NOT DEFINED BUILD_SHARED_LIBS)
     SET(BUILD_SHARED_LIBS ON)
@@ -239,11 +280,11 @@
 set_target_properties(czmq
     PROPERTIES DEFINE_SYMBOL "CZMQ_EXPORTS"
 )
-set_target_properties(czmq
-    PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${SOURCE_DIR}/src"
-)
 set_target_properties (czmq
-    PROPERTIES SOVERSION "4.0.2"
+    PROPERTIES SOVERSION "4"
+)
+set_target_properties (czmq
+    PROPERTIES VERSION "4.0.3"
 )
 target_link_libraries(czmq
     ${ZEROMQ_LIBRARIES} ${MORE_LIBRARIES}
@@ -260,7 +301,7 @@
 ########################################################################
 # pkgconfig
 ########################################################################
-set (VERSION "4.0.2")
+set (VERSION "4.0.3")
 set (prefix "${CMAKE_INSTALL_PREFIX}")
 set (exec_prefix "\${prefix}")
 set (libdir "\${prefix}/lib${LIB_SUFFIX}")
@@ -293,9 +334,28 @@
     ${LIBZMQ_LIBRARIES}
     ${OPTIONAL_LIBRARIES}
 )
-set_target_properties(
-    zmakecert
-    PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${SOURCE_DIR}/src"
+install(TARGETS zmakecert
+    RUNTIME DESTINATION bin
+)
+add_executable(
+    zsp
+    "${SOURCE_DIR}/src/zsp.c"
+)
+target_link_libraries(
+    zsp
+    czmq
+    ${LIBZMQ_LIBRARIES}
+    ${OPTIONAL_LIBRARIES}
+)
+add_executable(
+    test_randof
+    "${SOURCE_DIR}/src/test_randof.c"
+)
+target_link_libraries(
+    test_randof
+    czmq
+    ${LIBZMQ_LIBRARIES}
+    ${OPTIONAL_LIBRARIES}
 )
 add_executable(
     czmq_selftest
@@ -306,10 +366,6 @@
     czmq
     ${LIBZMQ_LIBRARIES}
     ${OPTIONAL_LIBRARIES}
-)
-set_target_properties(
-    czmq_selftest
-    PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${SOURCE_DIR}/src"
 )
 
 ########################################################################
@@ -348,6 +404,7 @@
     zpoller
     zsock
     zstr
+    zsys
     zuuid
     zauth
     zbeacon
@@ -355,69 +412,36 @@
     zmonitor
     zproxy
     zrex
-    zsys
 )
 
 IF (ENABLE_DRAFTS)
     list (APPEND TEST_CLASSES
+    zargs
     zproc
     ztimerset
     ztrie
     )
 ENDIF (ENABLE_DRAFTS)
 
-foreach(TEST_CLASS ${TEST_CLASSES})
-    add_test(
-        NAME ${TEST_CLASS}
-        COMMAND czmq_selftest --continue --verbose --test ${TEST_CLASS}
-    )
-    set_tests_properties(
-        ${TEST_CLASS}
-        PROPERTIES TIMEOUT ${CLASSTEST_TIMEOUT}
-    )
-endforeach(TEST_CLASS)
-
-include(CTest)
-
-########################################################################
-# cleanup
-########################################################################
-add_custom_target (distclean @echo Cleaning for source distribution)
-
-set(cmake_generated ${CMAKE_BINARY_DIR}/CMakeCache.txt
-                    ${CMAKE_BINARY_DIR}/cmake_install.cmake
-                    ${CMAKE_BINARY_DIR}/Makefile
-                    ${CMAKE_BINARY_DIR}/CMakeFiles
-                    ${CMAKE_BINARY_DIR}/CTestTestfile.cmake
-                    ${CMAKE_BINARY_DIR}/DartConfiguration.tcl
-                    ${CMAKE_BINARY_DIR}/Testing
-                    ${CMAKE_BINARY_DIR}/compile_commands.json
-                    ${CMAKE_BINARY_DIR}/src/platform.h
-                    ${CMAKE_BINARY_DIR}/src/libczmq.pc
-                    ${CMAKE_BINARY_DIR}/src/libczmq.so
-                    ${CMAKE_BINARY_DIR}/src/czmq_selftest
-                    ${CMAKE_BINARY_DIR}/src/zmakecert
-                    ${CMAKE_BINARY_DIR}/src/czmq_selftest
-)
-
-add_custom_command(
-    DEPENDS clean
-    COMMENT "distribution clean"
-    COMMAND rm
-    ARGS    -rf CMakeTmp ${cmake_generated}
-    TARGET  distclean
-)
-
-########################################################################
-# summary
-########################################################################
-message ("")
-message (STATUS "******************* Configuration Summary *******************")
-message (STATUS "General:")
-message (STATUS "  Version           :   ${VERSION}")
-message (STATUS "  System            :   ${CMAKE_SYSTEM_NAME}")
-message (STATUS "  C compiler        :   ${CMAKE_C_COMPILER}")
-message (STATUS "  Debug C flags     :   ${CMAKE_C_FLAGS_DEBUG} ${CMAKE_C_FLAGS}")
-message (STATUS "  Release C flags   :   ${CMAKE_C_FLAGS_RELEASE} ${CMAKE_C_FLAGS}")
-message (STATUS "  Build type        :   ${CMAKE_BUILD_TYPE}")
-IF (ENABLE_DRAFTS)
+IF (ENABLE_DRAFTS)
+    list (APPEND TEST_CLASSES
+    private_classes
+    )
+ENDIF (ENABLE_DRAFTS)
+
+
+add_custom_target(
+    copy-selftest-ro ALL
+    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/src/selftest-ro ${CMAKE_BINARY_DIR}/src/selftest-ro
+)
+
+add_custom_target(
+    make-selftest-rw ALL
+    COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_BINARY_DIR}/src/selftest-rw
+)
+
+set_directory_properties(
+    PROPERTIES
+    ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_BINARY_DIR}/src/selftest-ro;${CMAKE_BINARY_DIR}/src/selftest-rw"
+)
+
